﻿# Music admins - Music admins can force music, force stop and more.
# You can add more admins, just keep the syntax!
MusicAdmins = ["STEAM_0:1:26397964", "STEAM_0:1:7589873", "STEAM_ID_LAN"]

# For more configuration see:
# "../cfg/eventscripts/music/music.cfg"

## No more editing in this script!
import es
import popuplib
import esamlib
import playerlib
from usermsg import motd
from urllib2 import urlopen

import psyco
psyco.full()

ReplayArtist = {}
ReplayTrack = {}
ReplayURL = {}
NowPlayingArtist = {}
NowPlayingTrack = {}
NowPlayingURL = {}
MusicForcement = {}
ForceMusicArtist = {}
ForceMusicTrack = {}
ForceMusicURL = {}

variables = [
        ["music_version","v5.0.02CheeTaH-Public","The Music Menu script version.",1],
        ["music_database","html-cheetah.webs.com/music/musicdb.html","The Music Menu music database.",1],
        ["music_check_for_updates", "1", "If this is enabled, then the script will check for updates on script load and map start",0],
        ["music_show_motd", "1", "If this is enabled, then the MOTD will show when a song is chosen",0],
        ["music_adverts", "1", "If this is enabled, then an advert will be sent at 'every now and then'",0],
        ["music_allow_musicartist_cmd", "0", "If this is enabled, then users can type !musicartist <artist> - Might lagg!",0],
        ["music_not_admin_msg", "You ain't no admin!", "message to non admins, when they try to use a admin command",0],
        ["music_listening", "You are now listening to:", "message to give players, when they have chosen a song",0],
        ["music_stopped_msg", "You stopped listening to music!", "message to give players, when they have stop the music",0],
        ["music_replaying_msg", "You are now replaying:", "message to give players, when they replay a song",0],
        ["music_replaying_msg_unavailable", "It doesn't seems like you've listened to anything yet!", "message to give players, when they fail to replay a song",0],
        ["music_now_playing_msg", "You are currently listening to:", "message to give players on !nowplaying",0],
        ["music_now_playing_msg_nothing", "You aren't listening to anything currently!", "message to give players on !nowplaying, when they aren't listening to anything",0],
    ]

ConsoleCMDs = ["!musicshow", "!music", "!stop", "!replay", "!nowplaying", "!musicforce", "!musicforceall",
        "!musicforceperson", "!musicartist", "!musicbrowse", "!musicpanel", "!musicjoin"]
SayCMDs = ["!musicartist", "!musicbrowse"]

def load():
    MMinfo()
    MMmenu()
    for CMD in SayCMDs:
        block = "music/client_cmd_%s" %(str(CMD).replace("!", ""))
        es.regsaycmd(CMD, block, "Client Say Command")
    for CMD in ConsoleCMDs:
        block = "music/client_cmd_%s" %(str(CMD).replace("!", ""))
        es.regclientcmd(CMD, block, "Client Say Command")
    
    global MusicForceMenu
    MusicForceMenu = popuplib.easymenu("MusicForceMenu",None,MusicForceSelection)
    MusicForceMenu.settitle("Forcing Method:")
    MusicForceMenu.addoption("!music", "Force me (!Music)")
    MusicForceMenu.addoption("!musicforceall", "Force me (!MusicForceAll)")
    MusicForceMenu.addoption("!musicforceperson", "Force person (!MusicForcePerson)")
    
    global music_method
    music_method = popuplib.easymenu("music_method",None,MusicForceSelection)
    music_method.settitle("Choose A Method:")
    music_method.addoption("!musicshow", "View a list of songs")
    music_method.addoption("!musicbrowse youtube.com", "Search on Youtube")
    music_method.addoption("!musicbrowse grooveshark.com", "Search on GrooveShark")
    
    global musicmenu_panel
    musicmenu_panel = popuplib.easymenu("musicmenu_panel",None,MusicForceSelection)
    musicmenu_panel.settitle("Music Panel:")
    musicmenu_panel.addoption("!stop", "Stop Music")
    musicmenu_panel.addoption("!music", "Play Music")
    musicmenu_panel.addoption("!replay", "Replay a song")
    musicmenu_panel.addoption("!nowplaying", "Nowplaying menu")
    musicmenu_panel.addoption("!musicjoin", "Join another players song")
    musicmenu_panel.addoption("!musicforce", "Force a song")
    musicmenu_panel.addoption("!musicforcestop", "Force stop")
    
    global musicmenu_nowplaying
    musicmenu_nowplaying = popuplib.easymenu("musicmenu_nowplaying",None,NowPlayingBlock)
    musicmenu_nowplaying.settitle("Music Panel:")
    musicmenu_nowplaying.addoption("!NowPlayingTellAll", "Tell all what I listen to")
    musicmenu_nowplaying.addoption("!NowPlayingTellMeI", "Tell me what I listen to")
    musicmenu_nowplaying.addoption("!NowPlayingTellMe", "Tell me what other listen to [include not-listening-people]")
    musicmenu_nowplaying.addoption("!NowPlayingTellMeN", "Tell me what other listen to [don't include not-listening-people]")
    
def unload():
    for CMD in SayCMDs:
        es.unregsaycmd(CMD)
    for CMD in ConsoleCMDs:
        es.unregclientcmd(CMD)
                    
def es_map_start(ev):
    MMinfo()
    MMmenu()
    
def player_say(ev):
    text = str(ev["text"]).lower()
    userid = int(ev["userid"])
    if (text in ConsoleCMDs): es.cexec(userid, text)
    
def round_end(ev):
    if (es.ServerVar("music_adverts")):
        MusicTell("all", "is enabled. Type #green!music #defaultto see a list of songs. Type #green!stop#default to stop the music!")

def player_disconnect(ev):
    userid = int(ev['userid'])
    if userid in ReplayArtist:
        del ReplayArtist[userid]
        del ReplayTrack[userid]
        del ReplayURL[userid]
    if userid in NowPlayingArtist:
        del NowPlayingArtist[userid]
        del NowPlayingTrack[userid]
        del NowPlayingURL[userid]
    if userid in MusicForcement:
        del MusicForcement[userid]
    if userid in ForceMusicArtist:
        del ForceMusicArtist[userid]
        del ForceMusicTrack[userid]
        del ForceMusicURL[userid]
        
def MusicForceSelection(userid,choice,popupname):
    es.cexec(userid, choice)
            
def MMmenuhandle(userid,choice,popupname): # when an artist is picked
    popuplib.send("musicmenu_artist_%s"%choice,userid)
    
def MusicJoinBlock(userid,choice,popupname):
    if choice in NowPlayingArtist:
        MusicTell(userid, "You joined %ss song:" %(es.getplayername(choice)))
        MusicTell(choice, "%s joined your song:" %(es.getplayername(userid)))
        MusicTellSong(userid, NowPlayingArtist[choice], NowPlayingTrack[choice])
        MusicTellSong(choice, NowPlayingArtist[choice], NowPlayingTrack[choice])
        ReplayArtist[userid] = ReplayArtist[choice]
        ReplayTrack[userid] = ReplayTrack[choice]
        ReplayURL[userid] = ReplayURL[choice]
        NowPlayingURL[userid] = NowPlayingURL[choice]
        NowPlayingArtist[userid] = NowPlayingArtist[choice]
        NowPlayingTrack[userid] = NowPlayingTrack[choice]
        playURL(userid, NowPlayingURL[choice])
    else:
        MusicTell(userid, "%s isn't listening to anything!" %(es.getplayername(choice)))
    
def playURL(userid,URL,forceMOTD=0): # plays a URL
    motd(userid,2,"CheeTaH - Music Menu %s"%es.ServerVar("music_version"),"about:blank",False)
    if (URL.lower() != "stop"):
        if (es.ServerVar("music_show_motd")): Show = True
        if not (es.ServerVar("music_show_motd")): Show = False
        if (forceMOTD): Show = True
        motd(userid,2,"CheeTaH - Music Menu %s"%es.ServerVar("music_version"),URL,Show)

def MenuFix(Menu):
    Menu = str(Menu).lower().replace("&","").replace(" ","").replace("-","").replace("_","").replace("!","").replace("'","").replace("/","")
    Menu = str(Menu).replace(".","").replace(",","").replace("[","").replace("]","").replace("(","").replace(")","").replace("$","s")
    return Menu
        
def MusicTell(TellPerson, Message, MusicPrefix=1):
    if (MusicPrefix): Message2 = "\x05[Music] #default%s" %(Message)
    if not (MusicPrefix): Message2 = "#default%s" %(Message)
    if (str(TellPerson).lower() != "all"):
        if not es.exists('userid', TellPerson): return
        es.tell(TellPerson, "#multi", Message2)
    else:
        es.msg("#multi", Message2)
    
def MusicTellSong(TellPerson, artist, track):
    TellMSG = "\x05%s#default - \x05%s" %(artist, track)
    if (str(TellPerson).lower() == "all"):
        es.msg("#multi", TellMSG)
    else:
        if not es.exists('userid', TellPerson):
            return
        es.tell(TellPerson, "#multi", TellMSG)
    
def PlayerIsMusicAdmin(userid):
    if not es.exists('userid', userid):
        return False
    steamid = es.getplayersteamid(userid)
    if steamid in MusicAdmins:
        return True
    return False
    
def MMmusicmenu(artist): # put the songs in the artists menu (runs when "def menu" runs)
    if (music_allow_musicartist_cmd): artist = MenuFix(artist)
    musicsong = popuplib.easymenu("musicmenu_artist_%s"%artist,None,MMartisthandle)
    musicsong.settitle("Song Selection: \n %s" %(artist))
    for song in musicDB:
        songi = song.split("|")
        if (len(songi) == 3):
            if (music_allow_musicartist_cmd): songc = MenuFix(songi[1])
            if not (music_allow_musicartist_cmd): songc = songi[1]
            if (songc == artist): musicsong.addoption(songi,songi[2])
    musicsong.submenu(0,"musicmenu_artist_select")
        
def CheckMusicVersion():
    musicCurrentVersion = str(es.ServerVar("music_version")).replace("CheeTaH-Public", "").replace("v", "")
    musicWebsiteVersion = esamlib.getAddon('musicpython').currentversion
    es.dbgmsg(0, "----------------------")
    if (musicCurrentVersion == musicWebsiteVersion): es.dbgmsg(0, "Music version matches! (%s)" %(musicCurrentVersion))
    if not (musicCurrentVersion == musicWebsiteVersion):
        es.dbgmsg(0, "Server version: %s. ESAM version: %s." %(musicCurrentVersion, musicWebsiteVersion))
        es.dbgmsg(0, "Music version does not match the ESAM one. You can download ESAM version here::")
        es.dbgmsg(0, "www.addons.eventscripts.com/addons/view/musicpython")
    es.dbgmsg(0, "----------------------")
    
def NowPlayingBlock(userid,choice,popupname):
    if (choice == "!NowPlayingTellAll"): # Tell all what I listen to
        if userid in NowPlayingArtist:
            MusicTell("all", "%s is currently listening to:" %(es.getplayername(userid)))
            MusicTellSong("all", NowPlayingArtist[userid], NowPlayingTrack[userid])
        else:
            MusicTell("all", "%s is currently not listening to anything!" %(es.getplayername(userid)))
    elif (choice == "!NowPlayingTellMeI"): # Tell me what I listen to
        if userid in NowPlayingArtist:
            MusicTell(userid, es.ServerVar("music_now_playing_msg"))
            MusicTellSong(userid, NowPlayingArtist[userid], NowPlayingTrack[userid])
        else:
            MusicTell(userid, es.ServerVar("music_now_playing_msg_nothing"))
    elif (choice == "!NowPlayingTellMe"): # Tell me what other listen to [include not-listening-people]
        es.cexec(userid, "echo ----------------")
        es.cexec(userid, "echo Now Playing:")
        es.cexec(userid, "echo ----------------")
        MusicTell(userid, "Please check your console!")
        Players = playerlib.getUseridList('#human')
        for Player in Players:
            if Player in NowPlayingArtist:
                es.cexec(userid, "echo Player..: %s" %(str(es.getplayername(Player))))
                es.cexec(userid, "echo Artist..: %s" %(str(NowPlayingArtist[Player])))
                es.cexec(userid, "echo Track...: %s" %(str(NowPlayingTrack[Player])))
                es.cexec(userid, "echo URL.....: %s" %(str(NowPlayingURL[Player])))
            else:
                es.cexec(userid, "echo %s Is not listening to anything!" %(str(es.getplayername(Player))))
            es.cexec(userid, "echo ----------------")
    elif (choice == "!NowPlayingTellMeN"): # Tell me what other listen to [don't include not-listening-people]
        MusicTell(userid, "Please check your console!")
        MusicPeopleFound = 0
        es.cexec(userid, "echo ----------------")
        es.cexec(userid, "echo Now Playing:")
        es.cexec(userid, "echo ----------------")
        Players = playerlib.getUseridList('#human')
        for Player in Players:
            if Player in NowPlayingArtist:
                MusicPeopleFound += 1
                es.cexec(userid, "echo Player..: %s" %(str(es.getplayername(Player))))
                es.cexec(userid, "echo Artist..: %s" %(str(NowPlayingArtist[Player])))
                es.cexec(userid, "echo Track...: %s" %(str(NowPlayingTrack[Player])))
                es.cexec(userid, "echo URL.....: %s" %(str(NowPlayingURL[Player])))
                es.cexec(userid, "echo ----------------")
        if (MusicPeopleFound == 0):
            es.cexec(userid, "echo No players found!!")
            es.cexec(userid, "echo ----------------")
    
def MusicForcePersonBlock(userid,choice,popupname):
    if (choice != "UpdateList"):
        Players = playerlib.getUseridList('#human')
        for Player in Players:
            if (Player == userid):
                MusicTell(Player, "You forced %s to listen to:" %(es.getplayername(choice)))
            elif (Player == choice):
                MusicTell(Player, "%s forced you to listen to:" %(es.getplayername(userid)))
            else:
                MusicTell(Player, "%s forced %s to listen to:" %(es.getplayername(userid), es.getplayername(choice)))
        playURL(choice, ForceMusicURL[userid])
        MusicTellSong("all", ForceMusicArtist[userid], ForceMusicTrack[userid])
    CreateForceMenu(userid, ForceMusicURL[userid], ForceMusicArtist[userid], ForceMusicTrack[userid])
    
def CreateForceMenu(Player, URL, Artist, Track):
    ForceMusicArtist[Player] = Artist
    ForceMusicTrack[Player] = Track
    ForceMusicURL[Player] = URL
    if popuplib.exists('MusicForcePersonMenu'): popuplib.delete('MusicForcePersonMenu')
    global MusicForcePersonMenu
    MusicForcePersonMenu = popuplib.easymenu('MusicForcePersonMenu',None, MusicForcePersonBlock)
    MusicForcePersonMenu.settitle("Music %s" %str(es.ServerVar("music_version")).replace("CheeTaH-Public", "").replace("v", ""))
    MusicForcePersonMenu.setdescription("Choose a player to force to: \n%s - %s \n%s" %(Artist, Track, URL))
    MusicForcePersonMenu.addoption('UpdateList', '--- Update List ---')
    Players = playerlib.getUseridList('#all')
    Players = sorted(Players, key=lambda player: es.getplayername(player))
    if (Players): MusicForcePersonMenu.addoption('----------', ' ', 0)
    if not (Players): MusicForcePersonMenu.addoption('----------', 'No players found', 0)
    for Player in Players: MusicForcePersonMenu.addoption(Player, '%s (%s)' %(es.getplayername(Player), Player))
    MusicForcePersonMenu.send(Player)

def MMinfo(): # runs on script load and map change
    global musicDB
    for var in variables:
        vari = es.ServerVar(var[0],var[1],var[2])
        vari.set(var[1])
        if (var[3] == 1): vari.makepublic()
    es.mexec("../cfg/eventscripts/music/music.cfg")
    global music_allow_musicartist_cmd
    music_allow_musicartist_cmd = es.ServerVar("music_allow_musicartist_cmd")
    musicDB = urlopen(str("http://%s"%es.ServerVar("music_database"))).read().replace("\r","").split("\n")
    if (es.ServerVar("music_check_for_updates")): CheckMusicVersion()
        
def MMmenu(): # runs on script load and map change
    musicartist = popuplib.easymenu("musicmenu_artist_select",None,MMmenuhandle)
    musicartist.settitle("Artist Selection")
    musicartist.submenu(0,"music_method")
    ArtistUsed = {}
    for artists in musicDB:
        if artists.startswith("www."):
            artist = artists.split("|")
            if (len(artist) == 3):
                Artist = artist[1]
                if (music_allow_musicartist_cmd): ArtistLow = MenuFix(Artist)
                if not (music_allow_musicartist_cmd): ArtistLow = Artist
                if ArtistLow not in ArtistUsed:
                    ArtistUsed[ArtistLow] = "Used"
                    musicartist.addoption(ArtistLow,Artist)
                    MMmusicmenu(ArtistLow)
    
def MMartisthandle(userid,choice,popupname): # when a song is picked
    if userid not in MusicForcement: MusicForcement[userid] = 0
    if not (PlayerIsMusicAdmin(userid)): MusicForcement[userid] = 0
    MusicForcementValue = MusicForcement[userid]
    if (MusicForcementValue == 0):
        ReplayArtist[userid] = choice[1]
        ReplayTrack[userid] = choice[2]
        ReplayURL[userid] = choice[0]
        MusicTell(userid, es.ServerVar("music_listening"))
        MusicTellSong(userid, choice[1], choice[2])
        playURL(userid, choice[0])
        NowPlayingURL[userid] = choice[0]
        NowPlayingArtist[userid] = choice[1]
        NowPlayingTrack[userid] = choice[2]
    if (MusicForcementValue == 1):
        ReplayArtist[userid] = choice[1]
        ReplayTrack[userid] = choice[2]
        ReplayURL[userid] = choice[0]
        es.msg("#multi","\x05[Music] %s forced all to listen to:" %(es.getplayername(userid)))
        MusicTellSong("all", choice[1], choice[2])
        Players = playerlib.getUseridList('#human')
        for Player in Players:
            playURL(Player, choice[0])
            NowPlayingURL[userid] = choice[0]
            NowPlayingArtist[userid] = choice[1]
            NowPlayingTrack[userid] = choice[2]
    if (MusicForcementValue == 2): CreateForceMenu(userid, choice[0], choice[1], choice[2])

def client_cmd_music():
    player = int(es.getcmduserid())
    popuplib.send("music_method",player)
    MusicForcement[player] = 0
    
def client_cmd_musicshow():
    player = int(es.getcmduserid())
    popuplib.send("musicmenu_artist_select",player)
    MusicForcement[player] = 0

def client_cmd_stop():
    player = int(es.getcmduserid())
    playURL(player, "stop")
    MusicTell(player, es.ServerVar("music_stopped_msg"))
    if player in NowPlayingURL:
        del NowPlayingURL[player]
        del NowPlayingArtist[player]
        del NowPlayingTrack[player]

def client_cmd_nowplaying():
    player = int(es.getcmduserid())
    popuplib.send("musicmenu_nowplaying",player)

def client_cmd_replay():
    player = int(es.getcmduserid())
    if player in ReplayArtist:
        MusicTell(player, es.ServerVar("music_replaying_msg"))
        MusicTellSong(player, ReplayArtist[player], ReplayTrack[player])
        NowPlayingURL[player] = ReplayURL[player]
        NowPlayingArtist[player] = ReplayArtist[player]
        NowPlayingTrack[player] = ReplayTrack[player]
        playURL(player, ReplayURL[player])
    else:
        MusicTell(player, es.ServerVar("music_replaying_msg_unavailable"))

def client_cmd_musicforce():
    player = int(es.getcmduserid())
    if (PlayerIsMusicAdmin(player)):
        MusicForceMenu.send(player)
    else:
        MusicTell(player, es.ServerVar("music_not_admin_msg"))

def client_cmd_musicforceall():
    player = int(es.getcmduserid())
    if (PlayerIsMusicAdmin(player)):
        popuplib.send("musicmenu_artist_select",player)
        MusicForcement[player] = 1
    else:
        MusicForcement[player] = 0
        MusicTell(player, es.ServerVar("music_not_admin_msg"))

def client_cmd_musicforceperson():
    player = int(es.getcmduserid())
    if (PlayerIsMusicAdmin(player)):
        popuplib.send("musicmenu_artist_select",player)
        MusicForcement[player] = 2
    else:
        MusicForcement[player] = 0
        MusicTell(player, es.ServerVar("music_not_admin_msg"))

def client_cmd_musicartist():
    player = int(es.getcmduserid())
    if (music_allow_musicartist_cmd):
        if (es.getargs()):
            artist = MenuFix(es.getargs())
            artist = "musicmenu_artist_%s" %(artist)
            if popuplib.exists(artist):
                popuplib.send(artist,player)
            else:
                MusicTell(player, "Couldn't find the menu: %s" %(artist))
        else:
            MusicTell(player, "!MusicArtist <Artist>")
            MusicTell(player, "ex: '!MusicArtist Skillet', would send you to the Skillet-artist-menu")
    else:
        MusicTell(player, "!MusicArtist is disabled!")

def client_cmd_musicbrowse():
    player = int(es.getcmduserid())
    args = str(es.getargs())
    if ("." in args):
        playURL(player, args, 1)
    else:
        MusicTell(player, "!MusicBrowse <website>")
        MusicTell(player, "ex: '!MusicBrowse www.youtube.com', would send you to: http://www.youtube.com/")

def client_cmd_musicpanel():
    player = int(es.getcmduserid())
    popuplib.send("musicmenu_panel",player)

def client_cmd_musicjoin():
    player = int(es.getcmduserid())
    if popuplib.exists('musicmenu_musicjoin'): popuplib.delete('musicmenu_musicjoin')
    global musicmenu_musicjoin
    musicmenu_musicjoin = popuplib.easymenu("musicmenu_musicjoin",None,MusicJoinBlock)
    musicmenu_musicjoin.settitle("Music Join:")
    Players = playerlib.getUseridList('#all')
    for Player in Players:
        if Player in NowPlayingArtist:
            musicmenu_musicjoin.addoption(Player, "Player: %s" %(str(es.getplayername(Player))))
            musicmenu_musicjoin.addoption(Player, "Artist: %s" %(str(NowPlayingArtist[Player])))
            musicmenu_musicjoin.addoption(Player, "Track : %s" %(str(NowPlayingTrack[Player])))
        else:
            musicmenu_musicjoin.addoption(Player, "Player: %s" %(str(es.getplayername(Player))), 0)
            musicmenu_musicjoin.addoption(Player, "Artist: None", 0)
            musicmenu_musicjoin.addoption(Player, "Track : None", 0)
        musicmenu_musicjoin.addoption(0, " ", 0)
        musicmenu_musicjoin.addoption(0, " ", 0)
        musicmenu_musicjoin.addoption(0, " ", 0)
        musicmenu_musicjoin.addoption(0, " ", 0)
    musicmenu_musicjoin.send(player)